
Eina_Bool _efl_gfx_mapping_mapping_has(Eo *obj, Efl_Gfx_Mapping_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY(efl_gfx_mapping_has, Eina_Bool, 0);

void _efl_gfx_mapping_mapping_reset(Eo *obj, Efl_Gfx_Mapping_Data *pd);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODY(efl_gfx_mapping_reset);

void _efl_gfx_mapping_mapping_point_count_set(Eo *obj, Efl_Gfx_Mapping_Data *pd, int count);


static Eina_Error
__eolian_efl_gfx_mapping_mapping_point_count_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_mapping_point_count_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_point_count_set, EFL_FUNC_CALL(count), int count);

int _efl_gfx_mapping_mapping_point_count_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd);


static Eina_Value
__eolian_efl_gfx_mapping_mapping_point_count_get_reflect(const Eo *obj)
{
   int val = efl_gfx_mapping_point_count_get(obj);
   return eina_value_int_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gfx_mapping_point_count_get, int, 0);

Eina_Bool _efl_gfx_mapping_mapping_clockwise_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd);


static Eina_Value
__eolian_efl_gfx_mapping_mapping_clockwise_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_mapping_clockwise_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gfx_mapping_clockwise_get, Eina_Bool, 0);

void _efl_gfx_mapping_mapping_smooth_set(Eo *obj, Efl_Gfx_Mapping_Data *pd, Eina_Bool smooth);


static Eina_Error
__eolian_efl_gfx_mapping_mapping_smooth_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_mapping_smooth_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_smooth_set, EFL_FUNC_CALL(smooth), Eina_Bool smooth);

Eina_Bool _efl_gfx_mapping_mapping_smooth_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd);


static Eina_Value
__eolian_efl_gfx_mapping_mapping_smooth_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_mapping_smooth_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gfx_mapping_smooth_get, Eina_Bool, 0);

void _efl_gfx_mapping_mapping_alpha_set(Eo *obj, Efl_Gfx_Mapping_Data *pd, Eina_Bool alpha);


static Eina_Error
__eolian_efl_gfx_mapping_mapping_alpha_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_mapping_alpha_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_alpha_set, EFL_FUNC_CALL(alpha), Eina_Bool alpha);

Eina_Bool _efl_gfx_mapping_mapping_alpha_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd);


static Eina_Value
__eolian_efl_gfx_mapping_mapping_alpha_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_mapping_alpha_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gfx_mapping_alpha_get, Eina_Bool, 0);

void _efl_gfx_mapping_mapping_coord_absolute_set(Eo *obj, Efl_Gfx_Mapping_Data *pd, int idx, double x, double y, double z);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_coord_absolute_set, EFL_FUNC_CALL(idx, x, y, z), int idx, double x, double y, double z);

void _efl_gfx_mapping_mapping_coord_absolute_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd, int idx, double *x, double *y, double *z);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_gfx_mapping_coord_absolute_get, EFL_FUNC_CALL(idx, x, y, z), int idx, double *x, double *y, double *z);

void _efl_gfx_mapping_mapping_uv_set(Eo *obj, Efl_Gfx_Mapping_Data *pd, int idx, double u, double v);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_uv_set, EFL_FUNC_CALL(idx, u, v), int idx, double u, double v);

void _efl_gfx_mapping_mapping_uv_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd, int idx, double *u, double *v);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_gfx_mapping_uv_get, EFL_FUNC_CALL(idx, u, v), int idx, double *u, double *v);

void _efl_gfx_mapping_mapping_color_set(Eo *obj, Efl_Gfx_Mapping_Data *pd, int idx, int r, int g, int b, int a);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_color_set, EFL_FUNC_CALL(idx, r, g, b, a), int idx, int r, int g, int b, int a);

void _efl_gfx_mapping_mapping_color_get(const Eo *obj, Efl_Gfx_Mapping_Data *pd, int idx, int *r, int *g, int *b, int *a);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_gfx_mapping_color_get, EFL_FUNC_CALL(idx, r, g, b, a), int idx, int *r, int *g, int *b, int *a);

void _efl_gfx_mapping_translate(Eo *obj, Efl_Gfx_Mapping_Data *pd, double dx, double dy, double dz);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_translate, EFL_FUNC_CALL(dx, dy, dz), double dx, double dy, double dz);

void _efl_gfx_mapping_rotate(Eo *obj, Efl_Gfx_Mapping_Data *pd, double degrees, const Efl_Gfx_Entity *pivot, double cx, double cy);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_rotate, EFL_FUNC_CALL(degrees, pivot, cx, cy), double degrees, const Efl_Gfx_Entity *pivot, double cx, double cy);

void _efl_gfx_mapping_rotate_3d(Eo *obj, Efl_Gfx_Mapping_Data *pd, double dx, double dy, double dz, const Efl_Gfx_Entity *pivot, double cx, double cy, double cz);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_rotate_3d, EFL_FUNC_CALL(dx, dy, dz, pivot, cx, cy, cz), double dx, double dy, double dz, const Efl_Gfx_Entity *pivot, double cx, double cy, double cz);

void _efl_gfx_mapping_rotate_quat(Eo *obj, Efl_Gfx_Mapping_Data *pd, double qx, double qy, double qz, double qw, const Efl_Gfx_Entity *pivot, double cx, double cy, double cz);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_rotate_quat, EFL_FUNC_CALL(qx, qy, qz, qw, pivot, cx, cy, cz), double qx, double qy, double qz, double qw, const Efl_Gfx_Entity *pivot, double cx, double cy, double cz);

void _efl_gfx_mapping_zoom(Eo *obj, Efl_Gfx_Mapping_Data *pd, double zoomx, double zoomy, const Efl_Gfx_Entity *pivot, double cx, double cy);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_zoom, EFL_FUNC_CALL(zoomx, zoomy, pivot, cx, cy), double zoomx, double zoomy, const Efl_Gfx_Entity *pivot, double cx, double cy);

void _efl_gfx_mapping_lighting_3d(Eo *obj, Efl_Gfx_Mapping_Data *pd, const Efl_Gfx_Entity *pivot, double lx, double ly, double lz, int lr, int lg, int lb, int ar, int ag, int ab);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_lighting_3d, EFL_FUNC_CALL(pivot, lx, ly, lz, lr, lg, lb, ar, ag, ab), const Efl_Gfx_Entity *pivot, double lx, double ly, double lz, int lr, int lg, int lb, int ar, int ag, int ab);

void _efl_gfx_mapping_perspective_3d(Eo *obj, Efl_Gfx_Mapping_Data *pd, const Efl_Gfx_Entity *pivot, double px, double py, double z0, double foc);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_perspective_3d, EFL_FUNC_CALL(pivot, px, py, z0, foc), const Efl_Gfx_Entity *pivot, double px, double py, double z0, double foc);

void _efl_gfx_mapping_rotate_absolute(Eo *obj, Efl_Gfx_Mapping_Data *pd, double degrees, double cx, double cy);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_rotate_absolute, EFL_FUNC_CALL(degrees, cx, cy), double degrees, double cx, double cy);

void _efl_gfx_mapping_rotate_3d_absolute(Eo *obj, Efl_Gfx_Mapping_Data *pd, double dx, double dy, double dz, double cx, double cy, double cz);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_rotate_3d_absolute, EFL_FUNC_CALL(dx, dy, dz, cx, cy, cz), double dx, double dy, double dz, double cx, double cy, double cz);

void _efl_gfx_mapping_rotate_quat_absolute(Eo *obj, Efl_Gfx_Mapping_Data *pd, double qx, double qy, double qz, double qw, double cx, double cy, double cz);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_rotate_quat_absolute, EFL_FUNC_CALL(qx, qy, qz, qw, cx, cy, cz), double qx, double qy, double qz, double qw, double cx, double cy, double cz);

void _efl_gfx_mapping_zoom_absolute(Eo *obj, Efl_Gfx_Mapping_Data *pd, double zoomx, double zoomy, double cx, double cy);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_zoom_absolute, EFL_FUNC_CALL(zoomx, zoomy, cx, cy), double zoomx, double zoomy, double cx, double cy);

void _efl_gfx_mapping_lighting_3d_absolute(Eo *obj, Efl_Gfx_Mapping_Data *pd, double lx, double ly, double lz, int lr, int lg, int lb, int ar, int ag, int ab);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_lighting_3d_absolute, EFL_FUNC_CALL(lx, ly, lz, lr, lg, lb, ar, ag, ab), double lx, double ly, double lz, int lr, int lg, int lb, int ar, int ag, int ab);

void _efl_gfx_mapping_perspective_3d_absolute(Eo *obj, Efl_Gfx_Mapping_Data *pd, double px, double py, double z0, double foc);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_mapping_perspective_3d_absolute, EFL_FUNC_CALL(px, py, z0, foc), double px, double py, double z0, double foc);

Efl_Object *_efl_gfx_mapping_efl_object_constructor(Eo *obj, Efl_Gfx_Mapping_Data *pd);


void _efl_gfx_mapping_efl_object_destructor(Eo *obj, Efl_Gfx_Mapping_Data *pd);


static Eina_Bool
_efl_gfx_mapping_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_GFX_MAPPING_EXTRA_OPS
#define EFL_GFX_MAPPING_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_has, _efl_gfx_mapping_mapping_has),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_reset, _efl_gfx_mapping_mapping_reset),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_point_count_set, _efl_gfx_mapping_mapping_point_count_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_point_count_get, _efl_gfx_mapping_mapping_point_count_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_clockwise_get, _efl_gfx_mapping_mapping_clockwise_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_smooth_set, _efl_gfx_mapping_mapping_smooth_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_smooth_get, _efl_gfx_mapping_mapping_smooth_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_alpha_set, _efl_gfx_mapping_mapping_alpha_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_alpha_get, _efl_gfx_mapping_mapping_alpha_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_coord_absolute_set, _efl_gfx_mapping_mapping_coord_absolute_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_coord_absolute_get, _efl_gfx_mapping_mapping_coord_absolute_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_uv_set, _efl_gfx_mapping_mapping_uv_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_uv_get, _efl_gfx_mapping_mapping_uv_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_color_set, _efl_gfx_mapping_mapping_color_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_color_get, _efl_gfx_mapping_mapping_color_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_translate, _efl_gfx_mapping_translate),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_rotate, _efl_gfx_mapping_rotate),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_rotate_3d, _efl_gfx_mapping_rotate_3d),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_rotate_quat, _efl_gfx_mapping_rotate_quat),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_zoom, _efl_gfx_mapping_zoom),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_lighting_3d, _efl_gfx_mapping_lighting_3d),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_perspective_3d, _efl_gfx_mapping_perspective_3d),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_rotate_absolute, _efl_gfx_mapping_rotate_absolute),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_rotate_3d_absolute, _efl_gfx_mapping_rotate_3d_absolute),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_rotate_quat_absolute, _efl_gfx_mapping_rotate_quat_absolute),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_zoom_absolute, _efl_gfx_mapping_zoom_absolute),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_lighting_3d_absolute, _efl_gfx_mapping_lighting_3d_absolute),
      EFL_OBJECT_OP_FUNC(efl_gfx_mapping_perspective_3d_absolute, _efl_gfx_mapping_perspective_3d_absolute),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_gfx_mapping_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_gfx_mapping_efl_object_destructor),
      EFL_GFX_MAPPING_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"mapping_point_count", __eolian_efl_gfx_mapping_mapping_point_count_set_reflect, __eolian_efl_gfx_mapping_mapping_point_count_get_reflect},
      {"mapping_clockwise", NULL, __eolian_efl_gfx_mapping_mapping_clockwise_get_reflect},
      {"mapping_smooth", __eolian_efl_gfx_mapping_mapping_smooth_set_reflect, __eolian_efl_gfx_mapping_mapping_smooth_get_reflect},
      {"mapping_alpha", __eolian_efl_gfx_mapping_mapping_alpha_set_reflect, __eolian_efl_gfx_mapping_mapping_alpha_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_gfx_mapping_class_desc = {
   EO_VERSION,
   "Efl.Gfx.Mapping",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_Gfx_Mapping_Data),
   _efl_gfx_mapping_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_gfx_mapping_mixin_get, &_efl_gfx_mapping_class_desc, NULL, NULL);
